package be.iminds.ilabt.jfed.restapi.dao;

import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Frequency;
import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Result;
import be.iminds.ilabt.jfed.restapi.json.Experiment;
import org.skife.jdbi.v2.sqlobject.Bind;
import org.skife.jdbi.v2.sqlobject.BindBean;
import org.skife.jdbi.v2.sqlobject.SqlQuery;
import org.skife.jdbi.v2.sqlobject.SqlUpdate;
import org.skife.jdbi.v2.sqlobject.customizers.RegisterMapper;

import javax.validation.constraints.NotNull;
import java.sql.Timestamp;
import java.util.List;

@RegisterMapper(ExperimentMapper.class)
public interface ExperimentDao {
//    @SqlQuery("SELECT \"id\",\"name\",\"expire\",\"created\",\"request_rspec\",\"manifest_rspec\"," +
    @SqlQuery("SELECT \"id\",\"expire\",\"created\",\"request_rspec\",\"manifest_rspec\"," +
            "\"speaks_for_credential\",\"speaking_for\",\"project\",\"slice_name\",\"slice_urn\",\"am_url\"," +
            "array_to_string(\"shared_with\", ' ') AS shared_with_ssv,\"owner\",\"status\",CAST(\"status_details\" AS TEXT) AS status_details_text" +
            " FROM experiment " +
            " WHERE id=:id")
    Experiment findById(@NotNull @Bind("id") Long id);

    //array_to_string(rc.configset_id, ',') AS configset_id_csv


//    @SqlQuery("SELECT \"id\",\"name\",\"expire\",\"created\",\"request_rspec\",\"manifest_rspec\"," +
    @SqlQuery("SELECT \"id\",\"expire\",\"created\",\"request_rspec\",\"manifest_rspec\"," +
                "\"speaks_for_credential\",\"speaking_for\",\"project\",\"slice_name\",\"slice_urn\",\"am_url\"," +
                "array_to_string(\"shared_with\", ' ') AS shared_with_ssv,\"owner\",\"status\",CAST(\"status_details\" AS TEXT) AS status_details_text " +
                " FROM experiment ")
    List<Experiment> findAll();

    @SqlQuery("INSERT INTO experiment (id, expire, created, request_rspec, manifest_rspec,speaks_for_credential,\n" +
            "               speaking_for, project,slice_name,slice_urn,\n" +
            "               am_url, shared_with, owner, status, " +
            "               status_details) \n" +
                "VALUES (DEFAULT, :expire, :created, :requestRspec, :manifestRspec, :speaksForCredential, " +
            "            :speakingForAsString, :project, :sliceName, :sliceUrnAsString," +
            "            :amAsString, CAST(string_to_array(:sharedWithAsSsv, ' ') AS text[]), :ownerAsString, :statusAsString, " +
            "            CAST(:statusDetailsAsJsonString AS jsonb)) " +
                "RETURNING id")
    Long insert(@BindBean Experiment experiment);


    @SqlUpdate("UPDATE experiment set expire=:expire,created=:created,manifest_rspec=:manifestRspec,request_rspec=:requestRspec," +
            "            speaking_for=:speakingForAsString,project=:project,slice_name=:sliceName,slice_urn=:sliceUrnAsString," +
            "            am_url=:amAsString,owner=:ownerAsString,status=:statusAsString,status_details=CAST(:statusDetailsAsJsonString AS jsonb)," +
            "            shared_with=CAST(string_to_array(:sharedWithAsSsv, ' ') AS text[]),speaks_for_credential=:speaksForCredential " +
            " WHERE id=:id")
    void update(@BindBean Experiment res);
}
